//-----------------------------------------------------------------------------
// :
//     AD9959
//     : ǵ
// ʼ: 
// : 
// ޸:
//     : 
// Թ: 51Ƭ
// ˵    : 
//     (1)ʹõϵͳʱƵFsysclk=11.0592MHz
//     (2)Ӳӣ
// 							 AD9959_P0		-> P2^7;//
// 							 AD9959_P1		-> P2^6;
// 							 AD9959_P2 		-> P2^4;//
// 							 AD9959_P3 	  -> P2^2;
// 							 AD9959_IO_UD -> P2^1;//
// 							 AD9959_NC	  -> P2^0;
// 							 AD9959_SCLK  -> P1^2;//
// 							 AD9959_CS 		-> P1^3;
// 							 AD9959_SD0 	-> P1^4;//
// 							 AD9959_SD1 	-> P1^5;
// 							 AD9959_SD2 	-> P1^6;//
// 							 AD9959_SD3		-> P1^7;
// 							 AD9959_RST 	-> P3^2;//   
//						PW_Dӵصƽ
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// ͷļ
//-----------------------------------------------------------------------------
#include "ad9959.h"
#include "LCD1602.h"
// #include "delay.h"


//-----------------------------------------------------------------------------
// ͨĴַ궨
//-----------------------------------------------------------------------------
#define CSR 0x00               //ͨѡĴ
#define FR1 0x01               //ܼĴ1
#define FR2 0x02               //ܼĴ2
#define CFR 0x03               //ܼͨĴ
#define CFTW0 0x04             //32λͨƵתּĴ
#define CPOW0 0x05             //14λͨλתּĴ
#define ACR 0x06               //ȿƼĴ
#define SRR 0x07               //ɨ趨ʱ
#define RDW 0x08               //ɨ趨ʱ
#define FDW 0x09               //ɨ趨ʱ

#define SYSTEM_CLK 500000000

//-----------------------------------------------------------------
// void AD9959_Init()
//-----------------------------------------------------------------
//
// : AD9959ʼ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ:    
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_Init()
{
	AD9959_RST = 0;
	AD9959_RST = 1;
	AD9959_RST = 0;
	
	AD9959_CS = 1;
	AD9959_SCLK = 0;
	
	AD9959_SD0 = 0;
	AD9959_SD1 = 0;
	AD9959_SD2 = 0;
	AD9959_SD3 = 0;
	
	AD9959_P0 = 0;
	AD9959_P1 = 0;
	AD9959_P2 = 0;
	AD9959_P3 = 0;
	
	AD9959_IO_UD = 0;
	AD9959_NC = 0;
}

//-----------------------------------------------------------------
// void IO_UPdate(void)
//-----------------------------------------------------------------
//
// : һIO_UPDATAߵƽ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ:   
// ע: 
//     
//-----------------------------------------------------------------
void IO_UPdate(void)
{
	AD9959_IO_UD = 0;
	AD9959_IO_UD = 0;
	AD9959_IO_UD = 1;
	AD9959_IO_UD = 1;
	AD9959_IO_UD = 0;
}



//-----------------------------------------------------------------
// void AD9959_Write(unsigned char RegisterAddress, unsigned char NumberofRegisters, unsigned char *RegisterData,uchar temp)
//-----------------------------------------------------------------
//
// : дָ루ַݵAD9959
// ڲ: uchar RegisterAddressָ루ַ
//					 uchar NumberofRegistersдǼֽڵ
//					 uchar *RegisterData,uchar temp:ݵָ
// ز: 
// ȫֱ: 
// ģ:      
// ע:
//-----------------------------------------------------------------  
void AD9959_Write(unsigned char RegisterAddress, unsigned char NumberofRegisters, unsigned char *RegisterData,uchar temp)
{
	unsigned	char	ControlValue = 0;
	unsigned	char	ValueToWrite = 0;
	signed		char	RegisterIndex = 0;
	unsigned	char	i = 0;

	//Create the 8-bit header
	ControlValue = RegisterAddress;

	AD9959_SCLK = 0;
	AD9959_CS = 0;	 //bring CS low

	//Write out the control word
	for(i=0; i<8; i++)
	{
		AD9959_SCLK = 0;
		if(0x80 == (ControlValue & 0x80))
		{
			AD9959_SD0 = 1;	  //Send one to SDIO pin
		}
		else
		{
			AD9959_SD0 = 0;	  //Send zero to SDIO pin
		}
		AD9959_SCLK = 1;
		ControlValue <<= 1;	//Rotate data
	}
	AD9959_SCLK = 0;
	//And then the data
	for (RegisterIndex=0; RegisterIndex<NumberofRegisters; RegisterIndex++)
	{
		ValueToWrite = *(RegisterData + RegisterIndex );
		for (i=0; i<8; i++)
		{
			AD9959_SCLK = 0;
			if(0x80 == (ValueToWrite & 0x80))
			{
				AD9959_SD0 = 1;  //Send one to SDIO pin
			}
			else
			{
				AD9959_SD0 = 0;	  //Send zero to SDIO pin
			}
			AD9959_SCLK = 1;
			ValueToWrite <<= 1;	//Rotate data
		}
		AD9959_SCLK = 0;
	}	
	if(temp==1)
	  {
			IO_UPdate();
	  }	
	AD9959_CS = 1;	//bring CS high again
}


//-----------------------------------------------------------------
// FreTuning(double fre,uchar *FreData)
//-----------------------------------------------------------------
//
// : ʮƵƵֵת32λ
// ڲ: double freҪתƵ
//					 uchar *FreData32λƵݵָ
// ز: 
// ȫֱ: 
// ģ:     
// ע:
//-----------------------------------------------------------------  
void FreTuning(double fre,uchar *FreData)
{
	uchar z;	
	long int y;
	fre *= 4294967296.0 / SYSTEM_CLK;
	y = (long int)fre;
	
	z=(uchar)(y>>24);     //8λǿתΪ8λַ
	FreData[0]=z;
	
	z=(uchar)(y>>16);
	FreData[1]=z;
	
	z=(uchar)(y>>8);
	FreData[2]=z;
	
	z=(uchar)(y>>0);
	FreData[3]=z;
}


//-----------------------------------------------------------------
// void PhaTuning(double pha,uchar *PhaData)
//-----------------------------------------------------------------
//
// : ʮƵλֵת14λ
// ڲ: double phaҪתλ
//					 uchar *PhaData14λλݵָ
// ز: 
// ȫֱ: 
// ģ:      
// ע:
//-----------------------------------------------------------------  
void PhaTuning(double pha,uchar *PhaData)
{
	uchar z;
	
	long int y;
	pha *= 16384.0 / 360;
	y = (long int)pha;
	
  //8λǿתΪ8λַ
	
	z=(uchar)(y>>8);
	PhaData[0]=z;
	
	z=(uchar)(y>>0);
	PhaData[1]=z;
}


//-----------------------------------------------------------------
// void AmpTuningCW(double amp,uchar *AmpData)
//-----------------------------------------------------------------
//
// : ʮƵķֵת10λCW1~CW15
// ڲ: double ampҪתķ
//					 uchar *AmpData10λݵָ
// ز: 
// ȫֱ: 
// ģ:      
// ע:
//----------------------------------------------------------------- 
void AmpTuningCW(double amp,uchar *AmpData)
{
	uchar z;
	
	ulint y;
	amp *= 1024.0 / 1024;    //DAC
	y = (long int)amp;
	
  //8λǿתΪ8λַ
	
	z=(uchar)(y>>2);     //8λǿתΪ8λַ
	AmpData[0]= z ;
	z=(uchar)(y<<6);		// ȡ2λ
	AmpData[1] = (z & 0xC0);
	AmpData[2] = 0x00;
	AmpData[3] = 0x00;
}

//-----------------------------------------------------------------
// void AmpTuning(double amp,uchar *AmpData)
//-----------------------------------------------------------------
//
// : ʮƵķֵת10λ
// ڲ: double ampҪתķ
//					 uchar *AmpData10λݵָ
// ز: 
// ȫֱ: 
// ģ:      
// ע:
//----------------------------------------------------------------- 
void AmpTuning(double amp,uchar *AmpData)
{
	uchar z;
	
	ulint y;
	amp *= 1024.0 / 1024;    //DAC
	y = (long int)amp;
	
  //8λǿתΪ8λַ
	
	z=(uchar)(y>>8);    
	AmpData[1]= z ;
	z=(uchar)(y>>0);		
	AmpData[2] = z;
}



//-----------------------------------------------------------------
// void AD9959_ENCH1()
//-----------------------------------------------------------------
//
// : ͨ1ʹ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CSR,1,CHData0,0);    
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_ENCH1()
{
	uchar CHData0[1] = 0x40; 
	AD9959_Write(CSR,1,CHData0,0);
}


//-----------------------------------------------------------------
// void AD9959_ENCH2()
//-----------------------------------------------------------------
//
// : ͨ1ʹ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CSR,1,CHData1,0);    
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_ENCH2()
{
	uchar CHData1[1] = 0x80; 
	AD9959_Write(CSR,1,CHData1,0);
}


//Ƶģʽ******************************************

//-----------------------------------------------------------------
// void AD9959_SetFre(double fre)
//-----------------------------------------------------------------
//
// : õƵģʽƵ
// ڲ: double freƵ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);    
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetFre(double fre)
{
	uchar FreData[4];
	uchar CFRData[3] = {0x00,0x23,0x31};
	uchar FR1Data[3] = {0xd0,0x00,0x00};	

	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}



//-----------------------------------------------------------------
// void AD9959_SetPha(double fre,int pha)
//-----------------------------------------------------------------
//
// : õƵģʽƵʣʼλ
// ڲ: double freƵ
//					 int phaʼλ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData); PhaTuning(pha,PhaData);  
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetPha(double fre,int pha)
{
	uchar PhaData[2];
	uchar FreData[4];
	
	uchar FR1Data[3] = {0xd0,0x00,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	
	PhaTuning(pha,PhaData);
	AD9959_Write(CPOW0,2,PhaData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}



//-----------------------------------------------------------------
// void AD9959_SetAmp(double fre,int amp)
//-----------------------------------------------------------------
//
// : õƵģʽƵʣ
// ڲ: double freƵ
//					 int amp
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData); AmpTuning(amp,AmpData);  
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetAmp(double fre,int amp)			//899
{
	uchar AmpData[3] = {0xff,0x14,0xff};
	uchar FreData[4];
	
	uchar FR1Data[3] = {0xd0,0x00,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	
	AmpTuning(amp,AmpData);
 	AmpData[2] = 0xff; AmpData[1] = 0x17; 
	AD9959_Write(ACR,3,AmpData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//ģʽ*************************************************

//-----------------------------------------------------------------
// void AD9959_SetFreMod2(double fre1,double fre2)
//-----------------------------------------------------------------
//
// : 2FSKģʽƵ
// ڲ: double fre1Ƶ1
//					 double fre2Ƶ2
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetFreMod2(double fre1,double fre2)
{
	uchar Fre1Data[4];
	uchar Fre2Data[4];
	uchar CFRData[3] = {0x80,0x23,0x30};
	uchar FR1Data[3] = {0xd0,0x00,0x00};	

	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	FreTuning(fre1,Fre1Data);
	AD9959_Write(0x0a,4,Fre1Data,0);

	FreTuning(fre2,Fre2Data);
	AD9959_Write(CFTW0,4,Fre2Data,1);
}


//-----------------------------------------------------------------
// void AD9959_SetPhaMod2(double fre,int pha1,int pha2)
//-----------------------------------------------------------------
//
// : 2PSKģʽƵ,λ
// ڲ: double freƵ1
//					 int pha1λ1
//					 int pha2λ2
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);PhaTuning(pha1,PhaData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetPhaMod2(double fre,int pha1,int pha2)
{
	uchar PhaData[2];
	uchar FreData[4];
	
	uchar CFRData[3] = {0xc0,0x23,0x31};
	uchar FR1Data[3] = {0xd0,0x00,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	PhaTuning(pha1,PhaData);
	AD9959_Write(0x0a,4,PhaData,0);
	PhaTuning(pha2,PhaData);
	AD9959_Write(CPOW0,2,PhaData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SetAmpMod2(double fre,int amp1,int amp2)	
//-----------------------------------------------------------------
//
// : 2ASKģʽƵʣֵ
// ڲ: double freƵ1
//					 int amp11
//					 int amp22
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);AmpTuningCW(amp1,AmpData);AmpTuning(amp2,AmpData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetAmpMod2(double fre,int amp1,int amp2)			//899
{
	uchar AmpData[3] ;
	uchar FreData[4];
	
	uchar CFRData[3] = {0x40,0x03,0x30};
	uchar FR1Data[3] = {0xd0,0x00,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	AmpTuningCW(amp1,AmpData);
//  	AmpData[0] = 0xff; AmpData[1] |= 0x14; 
	AD9959_Write(0x0a,4,AmpData,0);

	AmpTuning(amp2,AmpData);
	AmpData[0] = 0xff; AmpData[1] |= 0x14; 
	AD9959_Write(ACR,3,AmpData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SetFreMod4(double fre1,double fre2,double fre3,double fre4)
//-----------------------------------------------------------------
//
// : 4FSKģʽƵ
// ڲ: double fre1Ƶ1
//					 double fre2Ƶ2
//					 double fre3Ƶ3
//					 double fre4Ƶ4
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetFreMod4(double fre1,double fre2,double fre3,double fre4)
{
	uchar FreData[4];
	uchar CFRData[3] = {0x80,0x23,0x30};
	uchar FR1Data[3] = {0xD0,0x51,0x00};	//ѡch2,ch34׵ƣP0P1ch2P2,P3ch3

	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	FreTuning(fre1,FreData);
	AD9959_Write(0x0a,4,FreData,0);
	FreTuning(fre2,FreData);
	AD9959_Write(0x0b,4,FreData,0);
	FreTuning(fre3,FreData);
	AD9959_Write(0x0c,4,FreData,0);

	FreTuning(fre4,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SetPhaMod4(double fre,int pha1,int pha2,int pha3,int pha4)
//-----------------------------------------------------------------
//
// : 4PSKģʽƵ,λ
// ڲ: double freƵ1
//					 int pha1λ1
//					 int pha2λ2
//					 int pha3λ3
//					 int pha4λ4
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);PhaTuning(pha1,PhaData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetPhaMod4(double fre,int pha1,int pha2,int pha3,int pha4)
{
	uchar PhaData[2];
	uchar FreData[4];
	
	uchar CFRData[3] = {0xc0,0x23,0x31};
	uchar FR1Data[3] = {0xD0,0x51,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);

	PhaTuning(pha1,PhaData);
	AD9959_Write(0x0a,4,PhaData,0);
	PhaTuning(pha2,PhaData);
	AD9959_Write(0x0b,4,PhaData,0);
	PhaTuning(pha3,PhaData);
	AD9959_Write(0x0c,4,PhaData,0);

	PhaTuning(pha4,PhaData);
	AD9959_Write(CPOW0,2,PhaData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SetAmpMod4(double fre,int amp1,int amp2,int amp3,int amp4)
//-----------------------------------------------------------------
//
// : 4ASKģʽƵʣֵ
// ڲ: double freƵ1
//					 int amp11
//					 int amp22
//					 int amp33
//					 int amp44
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);AmpTuningCW(amp1,AmpData);AmpTuning(amp2,AmpData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetAmpMod4(double fre,int amp1,int amp2,int amp3,int amp4)			//899
{
	uchar AmpData[3] ;
	uchar FreData[4];
	
	uchar CFRData[3] = {0x40,0x03,0x30};
	uchar FR1Data[3] = {0xD0,0x51,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	AmpTuningCW(amp1,AmpData);
// 	AmpData[2] = 0xff; AmpData[1] = 0x17; 
	AD9959_Write(0x0a,4,AmpData,0);

// 	AmpData[3] = 0x8f,0x14,0xff;
	AmpTuningCW(amp2,AmpData);
	AD9959_Write(0x0b,4,AmpData,0);
// 	AmpData[3] = 0x5f,0x14,0xff;
	AmpTuningCW(amp3,AmpData);
	AD9959_Write(0x0c,4,AmpData,0);

// 	AmpData[3] = 0xff,0x14,0xff;
	AmpTuning(amp4,AmpData);
	AmpData[0] = 0xff; AmpData[1] |= 0x14;
	AD9959_Write(ACR,3,AmpData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}





//-----------------------------------------------------------------
// void AD9959_SetFreMod8()
//-----------------------------------------------------------------
//
// : 8FSKģʽƵ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetFreMod8()
{
	uchar FreData[4];
	uchar CFRData[3] = {0x80,0x23,0x30};
	uchar FR1Data[3] = {0xD0,0x22,0x00};	//ѡch28׵ƣP0P1,P2

	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	FreTuning(200000,FreData);
	AD9959_Write(0x0a,4,FreData,0);
	FreTuning(300000,FreData);
	AD9959_Write(0x0b,4,FreData,0);
	FreTuning(400000,FreData);
	AD9959_Write(0x0c,4,FreData,0);
	FreTuning(500000,FreData);
	AD9959_Write(0x0d,4,FreData,0);
	FreTuning(600000,FreData);
	AD9959_Write(0x0e,4,FreData,0);
	FreTuning(700000,FreData);
	AD9959_Write(0x0f,4,FreData,0);
	FreTuning(800000,FreData);
	AD9959_Write(0x10,4,FreData,0);

	FreTuning(100000,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SetPhaMod8(double fre)
//-----------------------------------------------------------------
//
// : 8PSKģʽƵ
// ڲ: double freƵ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);PhaTuning(0,PhaData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetPhaMod8(double fre)
{
	uchar PhaData[2];
	uchar FreData[4];
	
	uchar CFRData[3] = {0xc0,0x23,0x31};
	uchar FR1Data[3] = {0xD0,0x22,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);

	PhaTuning(0,PhaData);
	AD9959_Write(0x0a,4,PhaData,0);
	PhaTuning(45,PhaData);
	AD9959_Write(0x0b,4,PhaData,0);
	PhaTuning(90,PhaData);
	AD9959_Write(0x0c,4,PhaData,0);
	PhaTuning(135,PhaData);
	AD9959_Write(0x0d,4,PhaData,0);
	PhaTuning(180,PhaData);
	AD9959_Write(0x0e,4,PhaData,0);
	PhaTuning(225,PhaData);
	AD9959_Write(0x0f,4,PhaData,0);
	PhaTuning(270,PhaData);
	AD9959_Write(0x10,4,PhaData,0);

	PhaTuning(315,PhaData);
	AD9959_Write(CPOW0,2,PhaData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SetAmpMod8(double fre)	
//-----------------------------------------------------------------
//
// : 8ASKģʽƵ
// ڲ: double freƵ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);	AmpTuning(100,AmpData);;AmpTuningCW(200,AmpData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetAmpMod8(double fre)			//899
{
	uchar AmpData[3] ;
	uchar FreData[4];
	
	uchar CFRData[3] = {0x40,0x03,0x30};
	uchar FR1Data[3] = {0xD0,0x22,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	AmpTuningCW(200,AmpData);
	AD9959_Write(0x0a,4,AmpData,0);

	AmpTuningCW(300,AmpData);
	AD9959_Write(0x0b,4,AmpData,0);

	AmpTuningCW(400,AmpData);
	AD9959_Write(0x0c,4,AmpData,0);

	AmpTuningCW(500,AmpData);
	AD9959_Write(0x0d,4,AmpData,0);

	AmpTuningCW(600,AmpData);
	AD9959_Write(0x0e,4,AmpData,0);

	AmpTuningCW(700,AmpData);
	AD9959_Write(0x0f,4,AmpData,0);
	
		AmpTuningCW(800,AmpData);
	AD9959_Write(0x10,4,AmpData,0);

	AmpTuning(100,AmpData);
	AmpData[0] = 0xff; AmpData[1] |= 0x14;
	AD9959_Write(ACR,3,AmpData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}



//-----------------------------------------------------------------
// void AD9959_SetFreMod16()
//-----------------------------------------------------------------
//
// : 16FSKģʽƵ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);;FreTuning(fre,FreData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetFreMod16()
{
	uchar FreData[4];
	uchar CFRData[3] = {0x80,0x23,0x30};
	uchar FR1Data[3] = {0xD0,0x23,0x00};	//ѡch28׵ƣP0P1,P2

	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	FreTuning(200000,FreData);
	AD9959_Write(0x0a,4,FreData,0);
	FreTuning(300000,FreData);
	AD9959_Write(0x0b,4,FreData,0);
	FreTuning(400000,FreData);
	AD9959_Write(0x0c,4,FreData,0);
	FreTuning(500000,FreData);
	AD9959_Write(0x0d,4,FreData,0);
	FreTuning(600000,FreData);
	AD9959_Write(0x0e,4,FreData,0);
	FreTuning(700000,FreData);
	AD9959_Write(0x0f,4,FreData,0);
	FreTuning(800000,FreData);
	AD9959_Write(0x10,4,FreData,0);
	FreTuning(900000,FreData);
	AD9959_Write(0x11,4,FreData,0);
	FreTuning(1000000,FreData);
	AD9959_Write(0x12,4,FreData,0);
	FreTuning(1100000,FreData);
	AD9959_Write(0x13,4,FreData,0);
	FreTuning(1200000,FreData);
	AD9959_Write(0x14,4,FreData,0);
	FreTuning(1300000,FreData);
	AD9959_Write(0x15,4,FreData,0);
	FreTuning(1400000,FreData);
	AD9959_Write(0x16,4,FreData,0);
	FreTuning(1500000,FreData);
	AD9959_Write(0x17,4,FreData,0);
	FreTuning(1600000,FreData);
	AD9959_Write(0x18,4,FreData,0);

	FreTuning(100000,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SetPhaMod16(double fre)
//-----------------------------------------------------------------
//
// : 16PSKģʽƵ
// ڲ: double freƵ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);PhaTuning(0,PhaData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetPhaMod16(double fre)
{
	uchar PhaData[2];
	uchar FreData[4];
	
	uchar CFRData[3] = {0xc0,0x23,0x31};
	uchar FR1Data[3] = {0xD0,0x23,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);

	PhaTuning(0,PhaData);
	AD9959_Write(0x0a,4,PhaData,0);
	PhaTuning(45,PhaData);
	AD9959_Write(0x0b,4,PhaData,0);
	PhaTuning(90,PhaData);
	AD9959_Write(0x0c,4,PhaData,0);
	PhaTuning(135,PhaData);
	AD9959_Write(0x0d,4,PhaData,0);
	PhaTuning(180,PhaData);
	AD9959_Write(0x0e,4,PhaData,0);
	PhaTuning(225,PhaData);
	AD9959_Write(0x0f,4,PhaData,0);
	PhaTuning(270,PhaData);
	AD9959_Write(0x10,4,PhaData,0);
		PhaTuning(0,PhaData);
	AD9959_Write(0x11,4,PhaData,0);
	PhaTuning(280,PhaData);
	AD9959_Write(0x12,4,PhaData,0);
	PhaTuning(290,PhaData);
	AD9959_Write(0x13,4,PhaData,0);
	PhaTuning(310,PhaData);
	AD9959_Write(0x14,4,PhaData,0);
	PhaTuning(320,PhaData);
	AD9959_Write(0x05,4,PhaData,0);
	PhaTuning(330,PhaData);
	AD9959_Write(0x16,4,PhaData,0);
	PhaTuning(340,PhaData);
	AD9959_Write(0x17,4,PhaData,0);
	PhaTuning(350,PhaData);
	AD9959_Write(0x18,4,PhaData,0);

	PhaTuning(315,PhaData);
	AD9959_Write(CPOW0,2,PhaData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SetAmpMod16(double fre)	
//-----------------------------------------------------------------
//
// : 16ASKģʽƵ
// ڲ: double freƵ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(CFTW0,4,FreData,1);	AmpTuning(100,AmpData);;AmpTuningCW(200,AmpData);
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SetAmpMod16(double fre)			//899
{
	uchar AmpData[3] ;
	uchar FreData[4];
	
	uchar CFRData[3] = {0x40,0x03,0x30};
	uchar FR1Data[3] = {0xD0,0x23,0x00};	
	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);
	
	AmpTuningCW(100,AmpData);
	AD9959_Write(0x0a,4,AmpData,0);

	AmpTuningCW(150,AmpData);
	AD9959_Write(0x0b,4,AmpData,0);

	AmpTuningCW(200,AmpData);
	AD9959_Write(0x0c,4,AmpData,0);

	AmpTuningCW(250,AmpData);
	AD9959_Write(0x0d,4,AmpData,0);

	AmpTuningCW(300,AmpData);
	AD9959_Write(0x0e,4,AmpData,0);

	AmpTuningCW(350,AmpData);
	AD9959_Write(0x0f,4,AmpData,0);
	
		AmpTuningCW(400,AmpData);
	AD9959_Write(0x10,4,AmpData,0);
	
	AmpTuningCW(450,AmpData);
	AD9959_Write(0x11,4,AmpData,0);

	AmpTuningCW(500,AmpData);
	AD9959_Write(0x12,4,AmpData,0);

	AmpTuningCW(550,AmpData);
	AD9959_Write(0x13,4,AmpData,0);

	AmpTuningCW(600,AmpData);
	AD9959_Write(0x14,4,AmpData,0);

	AmpTuningCW(650,AmpData);
	AD9959_Write(0x15,4,AmpData,0);

	AmpTuningCW(700,AmpData);
	AD9959_Write(0x16,4,AmpData,0);
	
		AmpTuningCW(750,AmpData);
	AD9959_Write(0x17,4,AmpData,0);
	
		AmpTuningCW(800,AmpData);
	AD9959_Write(0x18,4,AmpData,0);
	
	AmpTuning(50,AmpData);
	AmpData[0] = 0xff; AmpData[1] |= 0x14;
	AD9959_Write(ACR,3,AmpData,0);

	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//ɨƵģʽ*********************************************************

//-----------------------------------------------------------------
// void AD9959_SweepFre(double fre1,double fre2,double riss,double fall)
//-----------------------------------------------------------------
//
// : ɨƵģʽƵɨ
// ڲ: double fre1ʼƵʣ
//					 double fre2ֹƵ
//					 double rissٶ
//					 double fall½ٶ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(FR1,3,FR1Data,0);FreTuning(fre2,FreData);	   
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SweepFre(double fre1,double fre2,double riss,double fall)
{
	uchar FreData[4];
	uchar CFRData[3] = {0x80,0x63,0x21};
	uchar FR1Data[3] = {0xd0,0x00,0x00};	
	uchar SRRData[2] = {0xff,0xff};

	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);

	FreTuning(fre2,FreData);	
	AD9959_Write(0x0a,4,FreData,0);

	FreTuning(riss,FreData);	
	AD9959_Write(RDW,4,FreData,0);
	FreTuning(fall,FreData);	
	AD9959_Write(FDW,4,FreData,0);

	AD9959_Write(SRR,2,SRRData,0);			//ɨʱΪ

	
	FreTuning(fre1,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}

//-----------------------------------------------------------------
// void AD9959_SweepPha(double fre,double pha1,double pha2,double riss,double fall)
//-----------------------------------------------------------------
//
// : ɨƵģʽλɨ
// ڲ: double freƵ
//					 double pha1ʼλ
//					 double pha2ֹλ
//					 double rissٶ
//					 double fall½ٶ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(FR1,3,FR1Data,0);FreTuning(fre2,FreData);PhaTuning(pha1,PhaData); 
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SweepPha(double fre,double pha1,double pha2,double riss,double fall)
{
	uchar FreData[4];
	uchar PhaData[2];
	uchar CFRData[3] = {0xc0,0x63,0x21};
	uchar FR1Data[3] = {0xd0,0x00,0x00};	
	uchar SRRData[2] = {0xff,0xff}; 

	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);

	PhaTuning(pha2,PhaData);	
	AD9959_Write(0x0a,4,PhaData,0);
	PhaTuning(pha1,PhaData);	
	AD9959_Write(CPOW0,4,PhaData,0);

	PhaTuning(riss,PhaData);	
	AD9959_Write(RDW,4,PhaData,0);
	PhaTuning(fall,PhaData);	
	AD9959_Write(FDW,4,PhaData,0);

	AD9959_Write(SRR,2,SRRData,0);			//ɨʱΪ

	
	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// void AD9959_SweepAmp(double fre,double amp1,double amp2,double riss,double fall)
//-----------------------------------------------------------------
//
// : ɨƵģʽɨ
// ڲ: double freƵ
//					 double amp1ʼ
//					 double amp2ֹ
//					 double rissٶ
//					 double fall½ٶ
// ز: 
// ȫֱ: 
// ģ: AD9959_Write(FR1,3,FR1Data,0);FreTuning(fre2,FreData);AmpTuning(amp1,Amp1Data);	;AmpTuningCW(amp2,AmpData);	 
// ע: 
//     
//-----------------------------------------------------------------
void AD9959_SweepAmp(double fre,double amp1,double amp2,double riss,double fall)
{
	uchar FreData[4];
	uchar AmpData[4];
	uchar Amp1Data[3];
	uchar CFRData[3] = {0x40,0x63,0x21};
	uchar FR1Data[3] = {0xd0,0x00,0x00};	
	uchar SRRData[2] = {0xff,0xff}; 

	AD9959_Write(FR1,3,FR1Data,0);
	AD9959_Write(CFR,3,CFRData,0);

	AmpTuningCW(amp2,AmpData);	
	AD9959_Write(0x0a,4,AmpData,0);
	AmpTuning(amp1,Amp1Data);	
	AD9959_Write(ACR,3,Amp1Data,0);

	AmpTuningCW(riss,AmpData);	
	AD9959_Write(RDW,4,AmpData,0);
	AmpTuningCW(fall,AmpData);	
	AD9959_Write(FDW,4,AmpData,0);

	AD9959_Write(SRR,2,SRRData,0);			//ɨʱΪ

	
	FreTuning(fre,FreData);
	AD9959_Write(CFTW0,4,FreData,1);
}


//-----------------------------------------------------------------
// End Of File
//-----------------------------------------------------------------

