//-----------------------------------------------------------------
// :
//     HD44780(KS0066U)ں˵ַLCMӳ
//     : ǵ
// ʼ: 2014-02-01
// : 2014-02-02
// ޸: 2014-03-03
// ǰ汾: V1.0.2
// ʷ汾:
//	  -V1.0:(2014-02-02)Һʾ
//	-V1.0.1: (2014-02-16)ͷļвͷļ
//	-V1.0.2: (2014-03-03)ҺIO
// Թ: STM32Ŀ塢1602ҺLZE_ST_LINK2
// ˵    :
//     (1)ʹõϵͳʱƵFsysclk=72MHz;
//     (2)LCMĽӿڷʽ:ӿƷʽ;
//     (3)LCM(14-11)Ϳ߿Ժ͵ƬI/O,ʹ
//        ͨ,Ǿ,ҪڵƬΪ췽ʽ.
//     (4)LCMʼ,ʹʱҪѡ;
//     (5)BF/ACͶLCMݺһõ,ﲻд;
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// ͷļ
//-----------------------------------------------------------------
#include <stm32f10x.h>
#include "Delay.h"
#include "CharLCD.h"

//-----------------------------------------------------------------
// LCMCGRAMݶ
//-----------------------------------------------------------------
// ַ뼴CGROMĵַ
u8 CGTab[64]={
	0x08,0x0F,0x12,0x0F,0x0A,0x1F,0x02,0x02,	//""ַ=00H08H
   0x0F,0x09,0x0F,0x09,0x0F,0x09,0x11,0x00,	//""ַ=01H09H
   0x1F,0x11,0x11,0x1F,0x11,0x11,0x1F,0x00,	//""ַ=02H0AH
   0x11,0x0A,0x04,0x1F,0x04,0x1F,0x04,0x00,	//""ַ=03H0BH
   0x0E,0x00,0x1F,0x0A,0x0A,0x0A,0x13,0x00,	//"Ԫ"ַ=04H0CH
   0x18,0x18,0x07,0x08,0x08,0x08,0x07,0x00,	//""ַ=05H0DH
   0x0F,0x0F,0x0F,0x0A,0x0F,0x12,0x07,0x1F,	//""ַ=06H0EH
   0x00,0x00,0x0E,0x00,0x00,0x1F,0x00,0x00 	//""ַ=07H0FH
	};
// 0x04,0x04,0x04,0x07,0x04,0x04,0x1f,0x00,	//""ַ
// 0x1f,0x04,0x04,0x06,0x05,0x04,0x04,0x00,	//""ַ=07H

//-----------------------------------------------------------------
// ݱ:ʾ
//-----------------------------------------------------------------
u8 tab1[] = {
   0x57,0x65,0x6C,0x63,0x6F,0x6D,0x65,0x20,	// Welcome
   0x74,0x6F,0x20,				             			// to
   0x75,0x73,0x65,0x21,0x20                	// use!
	};	

u8 tab2[] = {
	0x54,0x65,0x6C,0x3A,                    	// Tel:
   0x31,0x33,0x39,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x38//13912345678
	};
u8 tabdy[] = {
   0x4D,0x44,0x44,0x2D,0x31,0x20,0x20,      // MDD-1
   0x03,0x33,0x35,0x38,0x2E,0x30,0x30,0x04,0x20,// 150.0Ԫ
   0x32,0x30,0x31,0x34,0x00,0x32,0x01,0x30,0x37,0x02,0x20,
   0x54,0x3D,0x31,0x35,0x05                 // T=32C
	};

//-----------------------------------------------------------------
// ȫֱ:RAM洢Ԫ
//-----------------------------------------------------------------
u8 lcdbuff;
u8 lcdbuff_1;

//-----------------------------------------------------------------
// ʼ
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// void LCM_Init (void)
//-----------------------------------------------------------------
//
// : LCMʼ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);CG_Write()     
// ע: 
//     (1)̲鿴HD44780(KS0066)ֲ;
//     (2)5VҺģ3.3VѹSTM32ƬӦ,ӿδ
//        ,Ҫ(4)ԹýгʼҺģ
//-----------------------------------------------------------------
void LCM_Init (void)
{
	u8 i;
	
	Delay_50ms(10);									// ʱȴҺȶ		
	GPIO_LCM_Configuration();				// ҺIOڳʼ
	for (i=5; i>0; i--)
	{
		WrCLcdC(0x28);						   	// LCM:4λݽӿ,25*7ʾ
	}
	WrCLcdC(0x01);						      // LCM
	WrCLcdC(0x06);						      // LCM뷽ʽ:дAC1
	WrCLcdC(0x0F);						      // LCMʾ:,˸ʾ
	WrCLcdC(0x0C);						      // LCMʾ:ʾ
	CG_Write();							      	// LCMԶַ
}

//-----------------------------------------------------------------
// void GPIO_LCM_Configuration(void)
//-----------------------------------------------------------------
//
// : LCM IO
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: RCC_APB2PeriphClockCmd();GPIO_Init();   
// ע: Ϊ
//			 			 
//			RS   	PD0			D4		PD4
//			RW		PD1			D5		PD5
//			E			PD2			D6		PD6
//										D7		PD7
//-----------------------------------------------------------------
void GPIO_LCM_Configuration(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	// ʹʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);  
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD, ENABLE);  
	// 									     	        RS		   		RW			  				    		 
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1
	//									D4						D5					D6						D7
								  | GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6| GPIO_Pin_7;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
	
	//																E
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
}
//-----------------------------------------------------------------
// ܳ
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// void WrCLcdC (u8 lcdcomm)
//-----------------------------------------------------------------
//
// : дLCMָ
// ڲ: LCMָ
// ز: 
// ȫֱ: lcdbuff:LCM/ݴ浥Ԫ,λ
// ģ: Wr_CodeData()     
// ע:
//-----------------------------------------------------------------
void WrCLcdC (u8 lcdcomm)
{
  lcdbuff = lcdcomm;
	lcdbuff_1 = lcdcomm;
	LCM_RS_clr;                             	// RS=0,RW=0,E=1-0:д
	LCM_RW_clr;
	Wr_CodeData();                      			// дLCMָ                             
}

//-----------------------------------------------------------------
// void WrCLcdD (u8 lcddata)
//-----------------------------------------------------------------
//
// : дLCMҪʾ
// ڲ: д
// ز: 
// ȫֱ: lcdbuff:LCM/ݴ浥Ԫ,λ
// ģ: Wr_CodeData()     
// ע:	 RS=1,RW=0,E=1-0:д
//-----------------------------------------------------------------
void WrCLcdD (u8 lcddata)
{
  lcdbuff = lcddata;
	lcdbuff_1 = lcddata;
	LCM_RS_set;                             
	LCM_RW_clr;	
	Wr_CodeData();
}

//-----------------------------------------------------------------
// void WriteString (u8 x, u8 y, u8 *s)
//-----------------------------------------------------------------
//
// : ָλʾһַ
// ڲ: x:, y:, *s:ַָ
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8)     
// ע: xֵֻΪ12, y16
//-----------------------------------------------------------------
void WriteString (u8 x, u8 y, u8 *s)          
{
	// LCMʾDDRAMʼַ
  if (x == 1)
		WrCLcdC(0x80+y-0x01);										// һ
	else 
		WrCLcdC(0xc0+y-0x01);										// ڶ
	// ʾַ					      	
	for ( ; *s != '\0'; s ++)
	{
		WrCLcdD (*s);	
	}	
}


//-----------------------------------------------------------------
// void Wr_CodeData (void)
//-----------------------------------------------------------------
//
// : дֳͬ
// ڲ:  
// ز: 
// ȫֱ: 
// ģ:      
// ע:  
//-----------------------------------------------------------------
 void Wr_CodeData (void)
{	
	// дֽ߰
	GPIOD->ODR &= 0Xff0f;											// λ
	lcdbuff &= 0xf0;        									// λ
	GPIOD->ODR |= lcdbuff;
	GPIOA->ODR &= 0xfeff;
	Delay_ns(1);
	LCM_E_set;                            		// Eߵ͵ƽʱΪ450ns
	Delay_ns(1);															// 2д̫ʾ
	LCM_E_clr;                            		// Eߵ͵ƽʱΪ450ns
	Delay_ns(1);
	// дͰֽ
	GPIOD->ODR &= 0xff0f;
	lcdbuff_1 &= 0x0f;
	lcdbuff_1 <<= 4;
	GPIOD->ODR |= lcdbuff_1;
	GPIOA->ODR &= 0xfeff;
	Delay_ns(1);
	LCM_E_set;                            	 
	Delay_ns(1);
	LCM_E_clr;                            	 
	Delay_1ms(5);
}

//-----------------------------------------------------------------
// void CG_Write (void)
//-----------------------------------------------------------------
//
// : Զַ͵CGRAM,Աʹʱ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8)     
// ע: 
//-----------------------------------------------------------------
void CG_Write (void)
{
	u8 i;

	WrCLcdC(0x40);						      					// LCMCGRAM׵ַ
	for (i=0; i<64; i++)                			// 85*8ַ
	{
		WrCLcdD(CGTab[i]);
	}
}

//-----------------------------------------------------------------
// void WrCLcd_char_num (u8 x, u8 y, u8 num)
//-----------------------------------------------------------------
//
// : ʾʮ޷ַ
// ڲ: x:, y:, num:޷ַ
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8)     
// ע: ʾݸʽΪ뷽ʽ; xֵֻΪ12, y16
//-----------------------------------------------------------------
void WrCLcd_char_num (u8 x, u8 y, u8 num)
{
	u8  zc_flag;  														// λΪ־
	u8 i;
	u8 date_bufc[4] = {"    "};	 					  	// 

	zc_flag = 0;  						     // '1':ƽʾѾзݳֹ

	// LCMʾDDRAMʼַ
  if (x == 1)
		WrCLcdC(0x80+y-0x01);										// һ
	else 
		WrCLcdC(0xc0+y-0x01);										// ڶ
	// ʾ	 								
	if (num != 0)
	{
		date_bufc[0] = ((num % 1000) / 100) + 48;// ȡλ
		date_bufc[1] = ((num % 100) / 10) + 48;
		date_bufc[2] = (num % 10) + 48;					// ȡλ
	
		for (i = 0; i < 3; i ++)
		{
			if ((date_bufc[i] != '0') && (zc_flag == 0))
			{
				zc_flag = 1;
			}
			if (zc_flag == 1)
			{
				WrCLcdD(date_bufc[i]);
			}
		}
	}
	else 
	{
		WrCLcdD('0');
	}
}

//-----------------------------------------------------------------
// void WrCLcd_int_num (u8 x, u8 y, u16  num)
//-----------------------------------------------------------------
//
// : ʾʮ޷
// ڲ: x:, y:, u8_num:޷
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8)     
// ע: ʾݸʽΪ뷽ʽ; xֵֻΪ12, y16
//-----------------------------------------------------------------
void WrCLcd_int_num (u8 x, u8 y, u16  num)
{
	u8   zi_flag;  														// λΪ־
	u8 i;
	u8 date_bufi[6] = {"      "};	 						// 

	zi_flag = 0;  									// '1':ƽʾѾзݳֹ

	// LCMʾDDRAMʼַ
  if (x == 1)
		WrCLcdC(0x80+y-0x01);										// һ
	else 
		WrCLcdC(0xc0+y-0x01);										// ڶ
	// ʾ	 								
	if (num != 0)
	{
		date_bufi[0] = ((num % 100000) / 10000) + 48;
		date_bufi[1] = ((num % 10000) / 1000) + 48;		
		date_bufi[2] = ((num % 1000) / 100) + 48;			
		date_bufi[3] = ((num % 100) / 10) + 48;				
		date_bufi[4] =  (num % 10) + 48;							
	
		for (i = 0; i < 5; i ++)
		{
			if ((date_bufi[i] != '0') && (zi_flag == 0))
			{
				zi_flag = 1;
			}
			if (zi_flag == 1)
			{
				WrCLcdD(date_bufi[i]);
			}
		}
	}
	else 
	{
		WrCLcdD('0');
	}
}

//-----------------------------------------------------------------
// void WrCLcd_long_num (u8 x, u8 y, unsigned long num)
//-----------------------------------------------------------------
//
// : ʾʮ޷ų
// ڲ: x:, y:, u8_num:޷ų
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8)     
// ע: ʾݸʽΪ뷽ʽ; xֵֻΪ12, y16
//-----------------------------------------------------------------
void WrCLcd_long_num (u8 x, u8 y, unsigned long num)
{	u8   zl_flag;  															// λΪ־
	u8 i;
	u8 date_bufl[11] = {"           "}; 				// 

	zl_flag = 0;  									 // '1':ƽʾѾзݳֹ

	// LCMʾDDRAMʼַ
  if (x == 1)
		WrCLcdC(0x80+y-0x01);											// һ
	else 
		WrCLcdC(0xc0+y-0x01);											// ڶ
	// ʾ	 								
	if (num != 0)
	{
		date_bufl[0] = ((num % 10000000000) / 1000000000) + 48;	 
		date_bufl[1] = ((num % 1000000000) / 100000000) + 48;		 
		date_bufl[2] = ((num % 100000000) / 10000000) + 48;			 
		date_bufl[3] = ((num % 10000000) / 1000000) + 48;			 
		date_bufl[4] = ((num % 1000000) / 100000) + 48;				 
		date_bufl[5] = ((num % 100000) / 10000) + 48;					 
		date_bufl[6] = ((num % 10000) / 1000) + 48;						 
		date_bufl[7] = ((num % 1000) / 100) + 48;							 
		date_bufl[8] = ((num % 100) / 10) + 48;							 
		date_bufl[9] =  (num % 10) + 48;											 
	
		for (i = 0; i < 10; i ++)
		{
			if ((date_bufl[i] != '0') && (zl_flag == 0))
			{
				zl_flag = 1;
			}
			if (zl_flag == 1)
			{
				WrCLcdD(date_bufl[i]);
			}
		}
	}
	else 
	{
		WrCLcdD('0');
	}
}

//-----------------------------------------------------------------
// Ӧó
//-----------------------------------------------------------------

//-----------------------------------------------------------------
// void Wr_In1 (void)
//-----------------------------------------------------------------
//
// : һʾWelcome to use!
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8)
// ע:
//----------------------------------------------------------------- 
void Wr_In1 (void)
{
	u8 i;
	// LCM뷽ʽ:дAC1
	WrCLcdC(0x06);						   
	// LCMʾDDRAMʼַ   
	WrCLcdC(0x80);						      
	for (i=0; i<15; i++)
	{
		WrCLcdD(tab1[i]);		
	}
}

//-----------------------------------------------------------------
// void Wr_In2 (void)
//-----------------------------------------------------------------
//
// : ڶʾTel:13950369220
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8)
// ע:
//----------------------------------------------------------------- 
void Wr_In2 (void)
{
	u8 i;
	// LCM뷽ʽ:дAC1
	WrCLcdC(0x06);					 
	// LCMʾDDRAMʼַ	      
	WrCLcdC(0xc0);						     
	for (i=0; i<15; i++)
	{
		WrCLcdD(tab2[i]);
	}
}

//-----------------------------------------------------------------
// void CL_Enter (void)
//-----------------------------------------------------------------
//
// : һַʾ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8);Delay_50ms(u8)
// ע:
//-----------------------------------------------------------------
void CL_Enter (void)
{
	u8 i;
	// LCM뷽ʽ:ACԼ1,治
	WrCLcdC(0x04);						         
	// һĩʼ
	WrCLcdC(0x8f);						   
	for (i=16; i>0; i--)
	{
		WrCLcdD(tab1[i-1]);
		Delay_50ms(2);
	}
}

//-----------------------------------------------------------------
// void CR_Enter (void)
//-----------------------------------------------------------------
//
// : ڶַʾ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8);Delay_50ms(u8)
// ע:
//-----------------------------------------------------------------
void CR_Enter (void)
{
	u8 i;
	// LCM뷽ʽ:AC1,治
	WrCLcdC(0x06);						       
	// ڶ׿ʼ
	WrCLcdC(0xc0);						     
	for (i=0; i<15; i++)
	{
		WrCLcdD(tab2[i]);
		Delay_50ms(2);
	}
}

//-----------------------------------------------------------------
// void L_Enter (void)
//-----------------------------------------------------------------
//
// : һַʾ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8);Delay_50ms(u8)
// ע:
//-----------------------------------------------------------------
void L_Enter (void)
{
	u8 i;
	// LCM뷽ʽ:AC1,ƽ
	WrCLcdC(0x07);						      
	// һĩʼ
	WrCLcdC(0x8f);						      
	for (i=0; i<15; i++)
	{
		WrCLcdD(tab1[i]);
		Delay_50ms(5);
	}
}

//-----------------------------------------------------------------
// void R_Enter (void)
//-----------------------------------------------------------------
//
// : һַʾ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8);Delay_50ms(u8)
// ע:
//-----------------------------------------------------------------
void R_Enter (void)
{
	u8 i;
	// LCM뷽ʽ:ACԼ1,ƽ
	WrCLcdC(0x05);						      	
	// һĩʼ
	WrCLcdC(0x8f);						      					
	for (i=15; i>0; i--)
	{
		WrCLcdD(tab1[i]);
		Delay_50ms(5);
	}
}

//-----------------------------------------------------------------
// void CGWrite (void)
//-----------------------------------------------------------------
//
// : ƷϢʾ
// ڲ: 
// ز: 
// ȫֱ: 
// ģ: WrCLcdC(u8);WrCLcdD(u8)
// ע:
//-----------------------------------------------------------------
void CGWrite (void)
{
	u8 i;

	WrCLcdC(0x06);
	WrCLcdC(0x80);                      			// һ
	for (i=0; i<16; i++)
	{
		WrCLcdD(tabdy[i]);		
	}
	WrCLcdC(0xc0);                      			// ڶ
	for (i=16; i<32; i++)
	{
		WrCLcdD(tabdy[i]);		
	}
}

//-----------------------------------------------------------------
// End Of File
//-----------------------------------------------------------------


