//-----------------------------------------------------------------
// AD9959ģӳͷļ
// ͷļ:ad9959.h
//     :ǵ
// дʱ:2017.08.1
// ޸:
//-----------------------------------------------------------------

#ifndef __ad9959_H__
#define __ad9959_H__

#include <reg52.h>


//-----------------------------------------------------------------
// ͺ궨
//-----------------------------------------------------------------
#define uchar unsigned char
#define uint unsigned int
#define ulint unsigned long int

//-----------------------------------------------------------------
// I/Oڶ:LCD/߽ӿ
//-----------------------------------------------------------------
sbit AD9959_P0		= P2^7;//
sbit AD9959_P1		= P2^6;
sbit AD9959_P2 		= P2^4;//
sbit AD9959_P3 	  = P2^2;
sbit AD9959_IO_UD = P2^1;//
sbit AD9959_NC	  = P2^0;
sbit AD9959_SCLK  = P1^2;//
sbit AD9959_CS 		= P1^3;
sbit AD9959_SD0 	= P1^4;//
sbit AD9959_SD1 	= P1^5;
sbit AD9959_SD2 	= P1^6;//
sbit AD9959_SD3		= P1^7;
sbit AD9959_RST 	= P3^2;//


//-----------------------------------------------------------------
// ⲿ
//-----------------------------------------------------------------


//-----------------------------------------------------------------
// ⲿ
//-----------------------------------------------------------------
extern void AD9959_Init(void);
extern void IO_UPdate(void);
// extern void AD9959_Write(uchar com,uchar byte_num,uchar *dat);
extern void AD9959_Write(unsigned char RegisterAddress, unsigned char NumberofRegisters, unsigned char *RegisterData,uchar temp);
extern void AD9959_ENCH1();
extern void AD9959_ENCH2();
extern void FreTuning(double fre,uchar *FreData);
extern void PhaTuning(double pha,uchar *PhaData);
extern void AmpTuning(double amp,uchar *AmpData);
extern void AmpTuningCW(double amp,uchar *AmpData);
extern void AD9959_SetFre(double fre);
extern void AD9959_SetPha(double fre,int pha);
extern void AD9959_SetAmp(double fre,int amp);
extern void AD9959_SetFreMod2(double fre1,double fre2);
extern void AD9959_SetAmpMod2(double fre,int amp1,int amp2);
extern void AD9959_SetPhaMod2(double fre,int pha1,int pha2);
extern void AD9959_SetFreMod4(double fre1,double fre2,double fre3,double fre4);
extern void AD9959_SetPhaMod4(double fre,int pha1,int pha2,int pha3,int pha4);
extern void AD9959_SetAmpMod4(double fre,int amp1,int amp2,int amp3,int amp4);
extern void AD9959_SetFreMod8();
extern void AD9959_SetPhaMod8(double fre);
extern void AD9959_SetAmpMod8(double fre);
extern void AD9959_SetFreMod16();
extern void AD9959_SetPhaMod16(double fre);
extern void AD9959_SetAmpMod16(double fre);
extern void AD9959_SweepFre(double fre1,double fre2,double riss,double fall);
extern void AD9959_SweepPha(double fre,double pha1,double pha2,double riss,double fall);
extern void AD9959_SweepAmp(double fre,double amp1,double amp2,double riss,double fall);

#endif


//-----------------------------------------------------------------
// End Of File
//-----------------------------------------------------------------